from rest_framework import serializers  # type:ignore
from rest_framework import viewsets, mixins
from .models import Product


class ProductSerializer(serializers.ModelSerializer):
    class Meta:
        model = Product
        fields = "__all__"


# https://git.disroot.org/nsukami/interview/src/branch/feat-1/src/modules/inventory/tests.py#L17
# a product can be created, updated, listed but not deleted
class ProductsViewSet(
    mixins.CreateModelMixin,
    mixins.ListModelMixin,
    mixins.UpdateModelMixin,
    mixins.RetrieveModelMixin,
    viewsets.GenericViewSet,
):
    queryset = Product.objects.all()
    serializer_class = ProductSerializer
