from django.db import models


class Order(models.Model):
    # https://git.disroot.org/nsukami/interview/src/branch/feat-1/src/modules/orders/tests.py#L55
    @property
    def total(self):
        return sum([x.total for x in self.items.all()])


class OrderItem(models.Model):
    # https://git.disroot.org/nsukami/interview/src/branch/feat-1/src/modules/orders/tests.py#L55
    order = models.ForeignKey(Order, related_name="items", on_delete=models.CASCADE)

    # https://git.disroot.org/nsukami/interview/src/branch/feat-1/src/modules/orders/tests.py#L59
    quantity = models.IntegerField(default=1)
    description = models.CharField(max_length=255)
    unit_price = models.FloatField()

    # https://git.disroot.org/nsukami/interview/src/branch/feat-1/src/modules/orders/tests.py#L63
    @property
    def total(self):
        # return self.product.unit_price * self.quantity
        return int(self.unit_price * self.quantity)
